<SCRIPT LANGUAGE="VBScript">
Option Explicit

' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT
' WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES
' OF MERCHANTABILITY AND/OR FITNESS FOR A  PARTICULAR
' PURPOSE

' SMTPBlockList.vbs
' -------------------------------
' SMTP Transport Event Sink to Block Emails with 
' attachements based on the File-Extension
' Running as SMTP transport Event Sink
' -------------------------------
'
' last change: 2004-05-19
' by: Simon.Dallmair@Faunwald.de
'
' Based on Code Fragments of 
'
' http://www.netatwork.de - fcarius, hkrause
' http://www.microsoft.com - but Microsoft's Script won't work^^
'
' Use "smtpreg.vbs Event Management Script" from msdn.microsoft.com
' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/smtpevt/html/_smtpevt_smtpreg_vbs_event_management_script.asp
' to register this File as an SMTP Event Sink 
'
' Register:
' cscript.exe smtpreg.vbs /add 1 onarrival BlockMail_RcptTo CDO.SS_SMTPOnArrivalSink "rcpt to=*"
' cscript.exe smtpreg.vbs /setprop 1 onarrival BlockMail_RcptTo Sink ScriptName "PathToScript(eg: c:\scripts) \SMTPBlockMessages.vbs"
'
' Unregister:
' cscript.exe smtpreg.vbs /remove 1 onarrival BlockMail_RcptTo

'************************************************************
'Change Constants

'Complete Filename of Log File
Const LogFile = "C:\EXScripte\BlockList.log"

' errorlogging  0=no logging, 1=Fatal  2=Error 3=Warning 4=information  5=debug
Const LogLevel = 5

'Block List: don't forget the last comma (,)! 
Const BlockList = "vbs,exe,pif,cmd,scr,js,"

'************************************************************
'Event sink

Sub ISMTPOnArrival_OnArrival(ByVal objMessage, EventStatus)
	On Error Resume Next

	AppendLog "Script started", 4
         
        Dim colAttachs 
        Set colAttachs = objMessage.Attachments

        Dim AttCount 
        AttCount = colAttachs.Count 
        AppendLog "Found " & AttCount & " Attachements", 5
        
        Dim oAttach
        Dim i
        Dim found
        Dim j

        ' I know, its much code, but:
        ' for each oAttach to colAttach 
        ' does not work correctly  (Win2k SP4 Exchange2K without SP cause of repair-installation)
        ' so assign the Object normal with the Item Property
        ' on the other hand are there some Exit For and a Test of AttCout, ists 
        ' only for a quicker algorithm

        'if there are Attachements
        if AttCount > 0 then 
                                                
          'Get an array with extensions from the List
          dim BlockAry
          BlockAry = Split(lcase(BlockList),",")
          AppendLog "Seraching for " & UBound(BlockAry) & " extensions", 4

          'loop over every Attachment
          For i = 1 to AttCount
            'Get Attachment 

            set oAttach = colAttachs.item(i)
            AppendLog "Attachement Name: " & oAttach.FileName, 4

            'loop over every Extension
            for j = 0 to UBound(BlockAry) - 1
              AppendLog "Searching for " & BlockAry(j), 5 

              'lock on the right side of the Filename, if the extension is 
              'in the Block list (beware about Case) then we found one
              if (lcase(right(oAttach.FileName, len(BlockAry(j)))) = BlockAry(j)) then
                found = true
                AppendLog "Found executeable Attachement: " & oAttach.FileName, 3
                Exit For  
              end if
            next
            if found then Exit For 
          next 
        end if 

	EventStatus = 0	

        'If found any Attachment to block
        If found Then 
  	  Dim envFlds
          Set envFlds = objMessage.EnvelopeFields 
          AppendLog "Message not delivered, droped to Badmail directory.", 3 

          'Set Status of Message to *BAD*
	  envFlds ("http://schemas.microsoft.com/cdo/smtpenvelope/messagestatus") = 3 
	  envFlds.Update  
	  'Commit the changes of the message status 
          'Skip remain event sinks 
	  EventStatus = 1
        Else
  	  AppendLog "No Attachement to Block found", 4
	End If
        
	if (err.number <> 0) Then AppendLog err.Description, true
	AppendLog "Script ended", 4

End Sub 

'******************************************************
' write a log File

Sub AppendLog(strLog, errlevel)
'Appends an entry to Logfile
	Dim file
	Dim fs

	if loglevel>=errlevel then
		Set fs = CreateObject("Scripting.FileSystemObject")
		Set file = fs.OpenTextFile(logfile, 8, true)
		file.Write(Now & ",")
		select case errlevel
			case 1	  file.Write("Fatal Line  ," & err.Source)
			case 2	  file.Write("Error       ")
			case 3	  file.Write("Warning     ")
			case 4	  file.Write("Information ")
			case 5	  file.Write("Debug       ")
			case else file.Write("Code        ," & errlevel)
		end select
		file.WriteLine(", "&strLog)
		file.Close
	end if
End Sub

</SCRIPT>
